package Editeur;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;

public class Composants extends JPanel{
    private JTextArea zoneTexte;
    private JTextField zoneSaisie;
    private JPanel lesBouttons,panelTexte;
    private JButton bValider,bEffacer,bAider,bStyle;
    private Ecouteur ecouteur;
    
    public Composants(){
	
	//Construction
	panelTexte=new JPanel();
	lesBouttons=new JPanel();
	zoneTexte=new JTextArea();
	zoneTexte.setEditable(false);
	zoneTexte.setAutoscrolls(true);
	zoneSaisie=new JTextField();
	bValider=new JButton("Valider");
	bEffacer=new JButton("Effacer");
	bAider=new JButton("Aider");
	bStyle=new JButton("Gras");
	JScrollPane scrollingArea = new JScrollPane(zoneTexte);

	//Layouts
	setLayout(new BorderLayout());
	panelTexte.setLayout(new BorderLayout());

	//Mise en forme
	add(zoneSaisie,BorderLayout.NORTH);
	add(panelTexte,BorderLayout.CENTER);
	panelTexte.add(scrollingArea);
	add(lesBouttons,BorderLayout.SOUTH);
	lesBouttons.add(bValider);
	lesBouttons.add(bEffacer);
	lesBouttons.add(bAider);
	lesBouttons.add(bStyle);
	

	//Bordure
	panelTexte.setBorder(BorderFactory.createEmptyBorder(10,0,0,0));
	setBorder(BorderFactory.createEmptyBorder(10,10,10,10));

	//Listeners
	ecouteur=new Ecouteur(this);
	zoneSaisie.addActionListener(ecouteur);
	bValider.addActionListener(ecouteur);
	bEffacer.addActionListener(ecouteur);
	bAider.addActionListener(ecouteur);
	bStyle.addActionListener(ecouteur);

	//Action command
	zoneSaisie.setActionCommand("Valider");
	bValider.setActionCommand("Valider");
	bEffacer.setActionCommand("Effacer");
	bAider.setActionCommand("Aider");
	bStyle.setActionCommand("ChangeStyle");
    }

    public void actionValider(){
	zoneTexte.append(zoneSaisie.getText()+"\n");
	zoneSaisie.setText("");
    }

    public void actionEffacer(){
	zoneTexte.setText("");
    }

    public void actionAider(){
	zoneTexte.setText("Bonjour, saisissez une ligne de texte  puis appuyez sur le retour chariot.");
    }

    public void actionChangerStyle(){
	Font font=zoneTexte.getFont();
	if(font.getStyle()==Font.PLAIN){
	    zoneTexte.setFont(font.deriveFont(Font.BOLD));
	    bStyle.setText("Normal");
	}
	else{
	    zoneTexte.setFont(font.deriveFont(Font.PLAIN));
	    bStyle.setText("Gras");
	}

    }

}
